=== algorithms/CMakeLists.txt ===


KOKKOS_SUBPACKAGE(Algorithms)

IF (NOT Kokkos_INSTALL_TESTING)
  ADD_SUBDIRECTORY(src)
ENDIF()
IF(NOT (KOKKOS_ENABLE_OPENMPTARGET AND KOKKOS_CXX_COMPILER_ID STREQUAL NVHPC))
  KOKKOS_ADD_TEST_DIRECTORIES(unit_tests)
ENDIF()

KOKKOS_SUBPACKAGE_POSTPROCESS()
