=== debian/changelog ===
kokkos (3.7.01-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix gcc-13 build issue. (Closes: #1043368)

 -- Bo YU <tsu.yubo@gmail.com>  Mon, 09 Oct 2023 15:49:00 +0800

kokkos (3.7.01-2) unstable; urgency=medium

  * d/control:
    - add Vcs fields.
    - add Build-Depends: libhwloc-dev, libnuma-dev, libmemkind-dev,
      libopenmpi-dev, pkgconf.
  * Bump standards version to 4.6.2.

 -- Gürkan Myczko <tar@debian.org>  Sun, 26 Feb 2023 18:25:39 +0100

kokkos (3.7.01-1) unstable; urgency=medium

  * Initial release (Closes: #1017786)

 -- Gürkan Myczko <tar@debian.org>  Thu, 09 Feb 2023 13:27:32 +0100
