=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DKokkos_ENABLE_HWLOC=ON \
	-DKokkos_ENABLE_LIBNUMA=ON \
	-DKokkos_ENABLE_MEMKIND=ON \
	-DKokkos_ENABLE_OPENMP=ON
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
